#version 460 compatibility

attribute vec4 mc_midTexCoord;
attribute vec4 at_tangent;
attribute vec4 mc_Entity;

#include "/HmwsLib/TAA.glsl"

uniform mat4 gbufferModelViewInverse;

flat out float matID;
out	float ao;
out vec2 Texcoord;
out vec2 Imcoord;
out vec3 Color;
flat out vec3 Tangent;
flat out vec3 Bitangent;
flat out vec3 Normal;
out vec3 worldPos;
out vec3 TexelPos;

void main()
{
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    DoTAAJitter(gl_Position);
    switch (int(mc_Entity.x)){	
		case 8 : matID = 4.0; break;
        case 9 : matID = 4.0; break;
        case 1971 : matID = 4.0; break;
        case 79 : matID = 5.0; break;
        case 95 : matID = 6.0; break;
        case 160 : matID = 6.0; break;
		default : matID = 0.0; break;
	}
	ao = gl_Color.a;
    Texcoord = gl_MultiTexCoord0.xy;
    Imcoord = gl_MultiTexCoord1.xy / 255.0f;
    Color = gl_Color.rgb;
    Tangent = normalize(gl_NormalMatrix * at_tangent.xyz);
    Normal = normalize(gl_NormalMatrix * gl_Normal);
    Bitangent = cross(Tangent, Normal);
    worldPos = (gbufferModelViewInverse * (gl_ModelViewMatrix * gl_Vertex)).xyz;
    TexelPos = mat3(Tangent.x, Bitangent.x, Normal.x,
                        Tangent.y, Bitangent.y, Normal.y,
                        Tangent.z, Bitangent.z, Normal.z) * (gl_ModelViewMatrix * gl_Vertex).xyz;
}